#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<ctype.h>

#define	CCT_VER		"cct v0.1"
#define	CCT_COPY	"(c) Marek Hon <carov@centrum.cz> 2001"
#define	CCT_FOR		"for Jaroslavek"

typedef struct {
  int l;
  char *q;
  char **r;
  int rs;
} tq;

static tq *q=NULL;
int qs;
char tn[256]="";

void
parse_file(FILE *f) {
  char r[128], *p; static tq *qa=NULL; int lc=0;
  
  while(fgets(r,127,f)) {
    lc++;
    if (r[0]=='#') continue;
    if (r[strlen(r)-1]=='\n') r[strlen(r)-1]=0;
    if (r[0]=='=') {
      if(tn[0]) printf("! Hej ty tam, bacha, jmeno testu definovano znovu! (radek %d).\n",lc); strcpy(tn,r+1); continue;
    }
    if (r[0]=='\'') {
      if(!qa) printf("! Clovece, zadavas odpoved jeste pred prvni otazkou! (radek %d).\n",lc); else
      { qa->rs++; qa->r=realloc(qa->r, qa->rs*sizeof(char *)); qa->r[qa->rs-1]=malloc(strlen(r)); strcpy(qa->r[qa->rs-1],r+1); }
      continue;
    }
    p=r; while(isspace(p[0])) p++; if (!p[0]) continue;
    if (qa && !qa->rs) printf("! Hele brouci, vis ze u minuly otazky nebyly zadny odpovedi? (radek %d)\n",qa->l);
    qs++; q=realloc(q,qs*sizeof(tq *));
    qa=&q[qs-1];
    q[qs-1].l=lc; q[qs-1].r=NULL; q[qs-1].rs=0;
    q[qs-1].q=malloc(strlen(r)+1);
    strcpy(q[qs-1].q,r);
  }
  if (!*tn) printf("! Nevidim tu nikde nazev testu, brouci.\n");
}

int
main(int argc, char **argv) {
  FILE *f;
  int qc;
  
  printf("%s %s %s\n",CCT_VER,CCT_COPY,CCT_FOR);

  if (argc<2) { printf("Sorry, nezadal jsi jmeno testu. Zkus to znovu, ok?\n"); return -1; }
  f=fopen(argv[1],"r");
  if (!f) { printf("Sorry, ale tenhle test neexistuje. Snad priste, broucku.\n"); return -1; }
  
  parse_file(f);

  fclose(f);

  if(!qs) { printf("Sorry, ale nikde tu nejsou zadne otazky.\n"); return -1; }
  
  for(qc=0;qc<qs;qc++) {
    int rc;
    printf("Otazka %d: %s\n",qc+1,q[qc].q);
    for (rc=0;rc<q[qc].rs; rc++)
      printf("%c) %s\n", "abcdefhijklmnopqrstuvwxyz"[rc], q[qc].r[rc]);
    printf("\n");
  }
}
