#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>

char plr[][4]={"=+-","#*%","OCc"};

typedef struct {
  unsigned int c; // obsazeno
} tceil;

tceil map[20][80];

typedef struct {
  unsigned int x, y;
  unsigned int t; // typ
  unsigned int h; // zivoty
  unsigned int e; // expy
  unsigned int a; // ammo (naboje)
  unsigned int p; // player
} tunit;

tunit *units;
unsigned int units_no=0;

int
map_paint() {
  int x,y;

  printf("\n-- =================================================================\n\n");
  printf("   "); for (x=0;x<80;x+=2) { printf(x<10?"  ":"%d ",x/10); } printf("\n");
  printf("   "); for (x=0;x<80;x+=2) { printf("%d ",x%10); } printf("\n");
  for (y=0; y<20; y++) {
    printf("%2d ",y);
    for (x=0; x<80; x++) {
      printf("%c",map[y][x].c?plr[units[map[y][x].c].p][3-units[map[y][x].c].h]:x%2?'.':':');
    }
    printf("\n");
  }
  printf("\n");
}

int
main() {
  int z,x,y;

  printf("Str v0.0.0\n\n");

  printf("Generating");
  units=malloc(21*sizeof(tunit));
  printf("units");
  for(z=1;z<11;z++) {
    x=rand()%40; y=rand()%20;
    units[z].p=1; units[z].x=x; units[z].y=y;
    units[z].a=10;units[z].e=0; units[z].h=3;
    map[y][x].c=z;
  }
  for(z=11;z<21;z++) {
    x=rand()%40+40; y=rand()%20;
    units[z].p=2; units[z].x=x; units[z].y=y;
    units[z].a=10;units[z].e=0; units[z].h=3;
    map[y][x].c=z;
  }
  
  while(1) {
    char c[128], *d;
    int x1,x2,y1,y2,t;
   
    map_paint();
    printf("Menu:\nm - move: m <x1>,<y1> <x2>,<y2>\nf - fire: f <x1>,<y1> <x2>,<y2>\ni - info: i <x1>,<y1>\nq - quit\n\nCommand: ");
    gets(c);
    d=c;

    switch (d[0]) {
      case 'm': d+=2;
		x1=atoi(d); d=strchr(d,',')+1; y1=atoi(d); d=strchr(d,' ')+1;
		x2=atoi(d); d=strchr(d,',')+1; y2=atoi(d);
		t=map[y1][x1].c;
		if (!t) {
		  printf("Neprud!\n"); break;
		}
		if (map[y2][x2].c) {
		  printf("Uhni!\n"); break;
		}
		z=ceil(sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)));
		if (z>units[t].e+2) {
		  printf("Brrrrrrrrrrrrrrrm...\n"); break;
		}
		map[y1][x1].c=0;
		map[y2][x2].c=t;
		units[t].x=x2; units[t].y=y2;
		break;
      case 'f': d+=2;
		x1=atoi(d); d=strchr(d,',')+1; y1=atoi(d); d=strchr(d,' ')+1;
		x2=atoi(d); d=strchr(d,',')+1; y2=atoi(d);
		t=map[y1][x1].c;
		if (!t) {
		  printf("Neprud!\n"); break;
		}
		if (!units[t].a) {
		  printf("Smula, broucku!\n"); break;
		}
		units[t].a--;
		if (!map[y2][x2].c) {
		  printf("Bum! A nic...\n"); break;
		}
		z=ceil(sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)));
		if (z>units[t].e+1) {
		  printf("Bum! A hopla...\n"); break;
		}
		units[map[y2][x2].c].h--;
		if (units[map[y2][x2].c].h<1) {
		  map[y2][x2].c=0;
		  printf("R.I.P.\n");
		}
		units[t].e++;
		break;
      case 'q': exit(0);
      case 'i': d+=2;
		x1=atoi(d);
		d=strchr(d,',')+1;
		y1=atoi(d);
		t=map[y1][x1].c;
		if (!t) {
		  printf("Neprud!\n"); break;
		}
		printf("Unit #%d, ammo %d, health %d, exp %d, player %d\n",t,units[t].a,units[t].h,units[t].e,units[t].p);
		break;
    }
  }
  
  return 0;
}
